Grid2StatusAuraGroupOptions = {}

local L = LibStub("AceLocale-3.0"):GetLocale("Grid2Options")
local LG = LibStub("AceLocale-3.0"):GetLocale("Grid2")


--{{{  Default Setup

-- {{displaySpellId, <false = any>|<true = mine>|<blinkThreshold>, r, g, b[, r, g, b]...}, spellId1, spellId2, ...}
function Grid2StatusAuraGroupOptions:SetupDefaultAuraGroups(setup, class)
	local setupIndicator = setup.status

	if (Grid2Options.healers[class]) then
		setup.auraGroups["group-hots"] = {{139, false, nil, .9, .3, .8, 1}, 139, 740, 774, 8936, 33763, 48438}

		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-left", "group-hots", 89)
	end

	if (class == "DRUID") then
		setup.auraGroups["group-GiftOfTheWild"] = {{26991, false, true, 1, 1, 0, 1}, 26991, 26990}
		setup.auraGroups["group-Swiftmend"] = {{18562, false, nil, .2, .6, 1, 1}, 774, 8936}

		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-GiftOfTheWild", 69)
		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-left", "group-Swiftmend", 99)
	elseif (class == "MAGE") then
		setup.auraGroups["group-DalaranBrilliance"] = {{61316, false, true, 0, 0, 1, 1}, 61316, 27126, 27127, 61024}

		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-DalaranBrilliance", 99)
	elseif (class == "PALADIN") then
		setup.auraGroups["group-BlessingOfKings"] = {{25898, false, true, 1, 0, .8, 1}, 20217, 25898}
		setup.auraGroups["group-BlessingOfMight"] = {{27141, false, true, 1, 0, .8, 1}, 27140, 27141}
		setup.auraGroups["group-BlessingOfSanctuary"] = {{25899, false, true, 1, 0, .8, 1}, 20911, 25899}
		setup.auraGroups["group-BlessingOfWisdom"] = {{27143, false, true, 1, 0, .8, 1}, 27142, 27143}

		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-BlessingOfKings", 99)
		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-BlessingOfMight", 99)
		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-BlessingOfSanctuary", 99)
		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-BlessingOfWisdom", 99)
	elseif (class == "PRIEST") then
		setup.auraGroups["group-ShadowProtection"] = {{39374, false, true, 1, 0, .8, 1}, 25433, 39374}
		setup.auraGroups["group-DivineSpirit"] = {{32999, false, true, 1, 0, .8, 1}, 27841, 32999}
		setup.auraGroups["group-PrayerOfFortitude"] = {{25392, false, true, 1, 0, .8, 1}, 25389, 25392}

		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-ShadowProtection", 99)
		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-DivineSpirit", 99)
		Grid2Options:SetupIndicatorStatus(setupIndicator, "side-bottom", "group-PrayerOfFortitude", 99)
	end
end

-- {{displaySpellId, <false = any>|<true = mine>|<blinkThreshold>, r, g, b[, r, g, b]...}, spellId1, spellId2, ...}
function Grid2StatusAuraGroupOptions:SetupDefaultAuraGroupDebuffs(setup, class)
	local setupIndicator = setup.status
	setup.auraGroupDebuffs["healing-prevented"] = {{55593, false, .9, 0, .8, 0.75}, 41292, 30843, 55593, 45996}
	setup.auraGroupDebuffs["healing-reduced"] = {{12294, false, .9, 0, .4, 1}, 19434, 56112, 48301, 12294, 13218, 43461, 13222, 13223, 13224, 27189, 57974, 57975, 32858, 38377, 40599, 34073, 13583, 23169, 45347, 63038, 36023, 36054, 34625, 34366, 32378, 19716, 52645, 36917, 22859, 54378, 28776, 60626, 30423, 59525, 45885, 54525, 35189, 32315, 28440, 44534}

	Grid2Options:SetupIndicatorStatus(setupIndicator, "alpha", "healing-prevented", 89)
	Grid2Options:SetupIndicatorStatus(setupIndicator, "border", "healing-reduced", 89)
	Grid2Options:SetupIndicatorStatus(setupIndicator, "corner-bottom-right", "healing-reduced", 89)
end
--/dump Grid2.statuses["healing-reduced"]:IsActive("player")

function Grid2StatusAuraGroupOptions:MakeDefaultSetup(setup, class)
	if (Grid2Options.healers[class]) then
		Grid2Options:SetupIndicatorTypeLocation(setup, "square", "side-left", "side-left", {7, "LEFT", "LEFT", 1, 0})
	end
	if (not setup.auraGroups) then
		setup.auraGroups = {}
		self:SetupDefaultAuraGroups(setup, class)
	end
	if (not setup.auraGroupDebuffs) then
		setup.auraGroupDebuffs = {}
		self:SetupDefaultAuraGroupDebuffs(setup, class)
	end
end

--}}}


local function getAuraGroupKey(name, mine)
	name = Grid2Options:GetValidatedName(name)
	if (name and name ~= "") then
		return "group-" .. name .. (mine and "-mine" or "")
	else
		return nil
	end
end

local newStatusAuraGroupName = ""
local function getNewStatusAuraGroupNameValue()
	return newStatusAuraGroupName
end
local function setNewStatusAuraGroupNameValue(info, auraGroupName)
	newStatusAuraGroupName = auraGroupName
end


local newStatusBuffMine = true
local function getNewStatusBuffMine()
	return newStatusBuffMine
end
local function setNewStatusBuffMine(info, mine)
	newStatusBuffMine = mine
end


local function NewStatusAuraGroup()
	local statusKey = getAuraGroupKey(newStatusAuraGroupName, newStatusBuffMine)
	if (statusKey) then
		local data = {newStatusAuraGroupName, true, nil, 1, 1, 1, 1}

		local auraGroups = Grid2.db.profile.setup.auraGroups
		auraGroups[statusKey] = data

		local status = Grid2:SetupStatusAuraBuff(statusKey, data)
		Grid2Options:AddAura("Buff", statusKey, unpack(data))
		Grid2Options:AddElementSubType("status", "group", status, MakeStatusStandardBuffOptions(status))
	end
end

local function NewStatusAuraGroupDisabled()
	local statusKey = getAuraGroupKey(newStatusAuraGroupName, newStatusBuffMine)
	if (statusKey) then
		local buffs = Grid2.db.profile.setup.buffs
		if (not buffs[statusKey]) then
			return false
		end
	end
	return true
end

function ResetAuraGroupStatuses()
	local setup = Grid2.db.profile.setup
	Grid2:SetupDefaultStatus(setup)
	Grid2Frame:UpdateAllFrames()
	Grid2Options:AddSetupStatusesOptions(setup, true)
end

local function MakeStatusAuraGroupCreateOptions(reset)
	local options = {
		newStatusAuraGroupName = {
			type = "input",
			order = 1,
			width = "full",
			name = L["Name"],
			usage = L["<CharacterOnlyString>"],
			get = getNewStatusAuraGroupNameValue,
			set = setNewStatusAuraGroupNameValue,
		},
		newStatusAuraGroupMine = {
			type = "toggle",
			order = 2,
			name = L["Show if mine"],
			desc = L["Display status only if the buff was cast by you."],
			get = getNewStatusBuffMine,
			set = setNewStatusBuffMine,
		},
		newStatusAuraGroup = {
			type = "execute",
			order = 5,
			name = L["New Status"],
			desc = L["Create a new status."],
			func = NewStatusAuraGroup,
			disabled = NewStatusAuraGroupDisabled,
		},
		resetAuraGroupStatuses = {
			type = "execute",
			order = 11,
			name = L["Reset Statuses"],
			desc = L["Reset statuses to defaults."],
			func = ResetAuraGroupStatuses,
		},
	}
	return options
end


function Grid2StatusAuraGroupOptions:AddSetupStatusesOptions(setup, reset)
	local status, options

	options = MakeStatusAuraGroupCreateOptions()
	Grid2Options:AddElementSubTypeGroup("status", "group", options, reset)
	for statusKey, info in pairs(setup.auraGroups) do
		local status = Grid2.statuses[statusKey] -- TODO: fix names more better.  Type should not get baked in.
		if (status) then
			options = Grid2Options:MakeStatusStandardBuffOptions(status)
			Grid2Options:AddElementSubType("status", "group", status, options)
		end
	end
	for statusKey, info in pairs(setup.auraGroupDebuffs) do
		local status = Grid2.statuses[statusKey] -- TODO: fix names more better.  Type should not get baked in.
		if (status) then
			options = Grid2Options:MakeStatusStandardBuffOptions(status)
			Grid2Options:AddElementSubType("status", "group", status, options)
		end
	end

end

